/* 
 * VirtualBox Control Service
 * 
 * Copyright © 2010 vu1tur.eu.org
 * 
 * This file is part of VirtualBox Control Service
 * 
 * VirtualBox Control Service is free software; you can redistribute it 
 * and/or modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * VirtualBox Control Service is distributed in the hope that it will 
 * be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */

#ifndef _vboxipcc_h
#define _vboxipcc_h

#include <windows.h>
#include <aclapi.h>

#define VBOX_PIPENAME_BASE "\\\\.\\pipe\\vboxctrl"
#define VBOXTRAY_PIPENAME "\\\\.\\pipe\\vboxctrltray"
#define VBOX_IPC_C_GETVRDPENABLED 0x00000100
#define VBOX_IPC_C_GETVRDPPORT 0x00000101
#define VBOX_IPC_C_GETVRDPRESOLUTION 0x00000102
#define VBOX_IPC_C_GETSTATE 0x00000103
#define VBOX_IPC_C_RELOAD 0x00000200

#define VBOX_MACHINESTATE_POWEREDOFF 1
#define VBOX_MACHINESTATE_SAVED 2
#define VBOX_MACHINESTATE_ABORTED 4
#define VBOX_MACHINESTATE_RUNNING 5
#define VBOX_MACHINESTATE_PAUSED 6
#define VBOX_MACHINESTATE_STUCK 7
#define VBOX_MACHINESTATE_STARTING 10
#define VBOX_MACHINESTATE_STOPPING 11
#define VBOX_MACHINESTATE_SAVING 12
#define VBOX_MACHINESTATE_RESTORING 13

BOOL VBoxIPCC_GetVRDPEnabled(const char *vmname);
LONG VBoxIPCC_GetVRDPPort(const char *vmname);
BOOL VBoxIPCC_GetVRDPResolution(const char *vmname, LONG *width, LONG *height);
LONG VBoxIPCC_GetState(const char *vmname);

void VBoxTrayIPCListener(void* args);
void VBoxTrayIPCDispatcher(HANDLE hp);
void VBoxTrayIPCReload();

#endif